Attribute VB_Name = "Error_Mod"
' All code Copyright (C) 1995 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.

Option Explicit

' A global to tell us where to log stuff to
Global logPath As String

' A global to tell us how much stuff to log
Global LogLevel As Integer

Sub Handle_Error(msg As String, Optional Terminate As Boolean = False)

    Write_Log "ERROR: " & msg, 1
    MsgBox (msg), vbExclamation, App.Title & " Error Wizard"
    If (Terminate) Then
        End
    End If
        
End Sub

Sub Handle_Information(msg As String, Optional Terminate As Boolean = False)

    Write_Log "INFO: " & msg, 4
    MsgBox (msg), vbInformation, App.Title
    If (Terminate) Then
        End
    End If
        
End Sub

Sub Handle_Critical(msg As String, Optional Terminate As Boolean = False)

    Write_Log "CRITICAL: " & msg, 1
    MsgBox (msg), vbCritical, App.Title & " Error Wizard"
    If (Terminate) Then
        End
    End If
        
End Sub

' Log information
Sub Write_Log(msg As String, Optional Level As Integer = 3)

' They don't want to hear this
If (Level > LogLevel) Then
    Exit Sub
End If

' Put it in app space. Much safer.
logPath = App.Path & "\" & App.ProductName & ".log"


' Abort silently on errors
On Error GoTo DamnThis
    Dim FF As Integer
    FF = FreeFile()
    ' Prepend the date stamp onto the entry
    msg = CStr(Now) & " - " & msg
    Open logPath For Append Access Write As #FF
    Print #FF, msg
    Close #FF
Exit Sub
        
DamnThis:
    Close #FF
    Exit Sub
    
End Sub
