Attribute VB_Name = "FileOps"
' All code Copyright (C) 1999 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.

'Couple globals for dir
Global Const vbDirAllFiles = 7
Global Const vbDirAllFilesFolders = 23

'Extract the drive from a path
Function Get_Drive(FilePath As String) As String

    Get_Drive = Left(FilePath, 2)
    
End Function
'EXtract the filename from a path
Function Get_Filename(FilePath As String) As String
    
    Get_Filename = Right(FilePath, Len(FilePath) - InStrRev(FilePath, "\", , vbTextCompare))
    
End Function

'EXtract the folderpath from a full filepath
Function Get_FolderPath(FilePath As String) As String
    
    Get_FolderPath = Left(FilePath, InStrRev(FilePath, "\", , vbTextCompare))
    
End Function

'Does the thing exist?
Function Thing_Exists(thingPath As String) As Boolean
    On Error GoTo TEError
    
    Dim FS
    
    FS = Dir(thingPath, vbDirAllFilesFolders)
    If (Len(FS)) Then
        Thing_Exists = True
    Else
        Thing_Exists = False
    End If
    
    Exit Function
TEError:
    Write_Log "THINGEXISTS: " & Err.Number & ": " & Err.Description, 4
    Thing_Exists = False

End Function
' Does the file exist?
Function File_Exists(FilePath As String) As Boolean
    
    On Error GoTo FiError
    
    If (FileLen(FilePath)) Then
        File_Exists = True
    Else
        File_Exists = False
    End If
    
    Exit Function
FiError:
    Write_Log "FILEEXISTS: " & Err.Number & ": " & Err.Description, 4
    File_Exists = False
Exit Function

End Function
' Does the folder exist?
Function Folder_Exists(folderPath As String) As Boolean
    Dim FS
    ' Sanity check
    If (Right(folderPath, 1) <> "\") Then
        folderPath = folderPath & "\"
    End If
    
    On Error GoTo FError
    
    FS = Dir(folderPath, vbDirectory)
    If (FS = "") Then
        Folder_Exists = False
    Else
        Folder_Exists = True
    End If
    
    Exit Function
FError:
    Write_Log "FOLDEREXISTS: " & Err.Number & ": " & Err.Description, 4
    Folder_Exists = False

End Function
