VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Hash"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' All code Copyright (C) 1999 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.


' ***Requires MArray class***

Option Explicit

' number of entries
Private mVarsize As Integer

' array of keys
Private mKeys As New MArray

'array of phrases
Private mValues As New MArray
' as you can guess I'm sure there is a 1-1 mapping between
'  mKeys and mValues. This is a makeshift hash if you will as VB
'  has no concept of one natively. Long live Perl.

' Initialize all of the globals on creation
Private Sub InitProperties()
    mVarsize = 0
End Sub

' Allows a LanguagePack to be populated with bulk data in the
'  Key = Phrase format
Public Sub Initialize(ByRef initialValue As Variant)

    If (IsArray(initialValue)) Then
        Dim c As Integer
        c = 0
        While (c <= UBound(initialValue))
            Dim parts As Variant
            parts = Split(initialValue(c), "=", 2)
            mKeys.Push Trim(parts(0))
            mValues.Push Trim(parts(1))
            c = c + 1
            mVarsize = c
        Wend
    End If
    
End Sub

'Allows an existing Hash to be updated.
'  If a name/value pair doesn't already exist, a new entry is made.
Public Sub Update(ByRef newVal As Variant)

    Dim c As Integer
    c = 0
    While (c <= UBound(newVal))
        Dim parts As Variant, place As Integer
        parts = Split(newVal(c), "=", 2)
        place = Find(Trim(parts(0)))
        If (place < 0) Then
            ' not here, must be new
            Push newVal(c)
        Else
            ' update it
            mValues.Change place, Trim(parts(1))
        End If
        c = c + 1
    Wend
End Sub

' This function returns a value, given its name
Public Function Value(ByVal Key As String) As Variant

    Dim place As Integer
    place = Find(Key)
    If (place < 0) Then
        Value = ""
    Else
        Value = mValues.See(place)
    End If

End Function

' Used internally to find the index of a key
Private Function Find(ByVal Key As String) As Integer

    Dim c As Integer
    c = 0
    While (c < mVarsize)
        If (StrComp(LCase(Key), LCase(mKeys.See(c))) = 0) Then
            Find = c
            Exit Function
        End If
        c = c + 1
    Wend
    Find = -1
    
End Function

' returns the number of elements.
Public Property Get Size() As Integer

    Size = mVarsize
    
End Property

' returns a Key = Phrase line from the "top" of the stack and removes it
Public Function Pop() As Variant

    Dim Ret As Variant
    Ret = mKeys.Pop & " = " & mValues.Pop
    mVarsize = mVarsize - 1
    
    Pop = Ret

End Function

' Adds a Key = Phrase to the "top" of the stack
Public Sub Push(ByVal vValue As Variant)
    Dim parts As Variant
    parts = Split(vValue, "=", 2)
    
    mKeys.Push Trim(parts(0))
    mValues.Push Trim(parts(1))
    mVarsize = mVarsize + 1
    
End Sub


' Updates an entry
Public Sub Change(ByVal Key As Variant, ByVal vValue As Variant)
    Dim parts As Variant, Element As Integer
    parts = Split(vValue, "=", 2)
    Element = Find(Key)
    mKeys.Change Element, Trim(parts(0))
    mValues.Change Element, Trim(parts(1))
    
End Sub

' returns Key = Value
Public Function SeePair(ByVal Element As Integer) As Variant

    SeePair = mKeys.See(Element) & " = " & mValues.See(Element)
    
End Function

'returns the MArray of mKeys
Public Function GetKeys() As MArray
    Dim gKeys As MArray
    Set gKeys = New MArray
    gKeys.Initialize mKeys.Give
    Set GetKeys = gKeys

End Function
