VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LanguagePack"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' All code Copyright (C) 2002 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.

' ***Requires MArray and Hash classes***

Option Explicit

' number of entries
Private mVarsize As Integer

'high level name for the language
Private sLangName As String

'author of the language file
Private sLangAuthor As String

' array of keys
Private LangData As New Hash

' Initialize all of the globals on creation
Private Sub InitProperties()
    mVarsize = 0
    sLangName = ""
    sLangAuthor = ""
End Sub

' Allows a LanguagePack to be populated with bulk data in the
'  Key = Phrase format
Public Sub Initialize(initialValue As Variant)
    'mVarsize = 0
    'Set LangData = New Hash

    If (IsArray(initialValue)) Then
        ' Give props
        sLangName = initialValue(0)
        sLangAuthor = initialValue(1)
    
        Resize initialValue
    
        LangData.Initialize initialValue
        mVarsize = LangData.Size
    End If

    
End Sub

'Allows an existing LanguagePack to be updated.
'  If a name/value pair doesn't already exist, a new entry is made.
Public Sub Update(newVal As Variant)

    sLangName = newVal(0)
    sLangAuthor = newVal(1)
    
    Resize newVal

    LangData.Update newVal
    mVarsize = LangData.Size
    
End Sub

' This is a poorly named function. It essentially returns
'   a phrase given a key
Public Function SeeByName(Key As String) As Variant

    SeeByName = LangData.Value(Key)

End Function


'returns the language name
Public Property Get Name() As String
    
    Name = sLangName
    
End Property

'returns the language author
Public Property Get author() As String
    author = sLangAuthor
End Property

' returns the number of elements.
Public Property Get Size() As Integer

    Size = mVarsize
    
End Property

' returns a Key = Phrase line from the "top" of the stack and removes it
Public Function Pop() As Variant

    Dim Ret As Variant
    Ret = LangData.Pop
    
    mVarsize = LangData.Size
    
    Pop = Ret

End Function

' Another poorly named function. This one returns the Phrase specified by
'   Key, and substitutes elipses in the phrase with upto 3 substrings.
'   Easily scaled. Could use an array, but I wanted to hard-code it to
'   prevent run-aways
Public Function ProperString(Key As String, Optional v1 As String = "", Optional v2 As String = "", Optional v3 As String = "") As String
    Dim Phrase As String
    Phrase = LangData.Value(Key)
    If (v1 <> "") Then
        Phrase = Replace(Phrase, "...", v1, , 1)
    End If
    If (v2 <> "") Then
        Phrase = Replace(Phrase, "...", v2, , 1)
    End If
    If (v3 <> "") Then
        Phrase = Replace(Phrase, "...", v3, , 1)
    End If
    
    ProperString = Phrase

End Function

' Adds a Key = Phrase to the "top" of the stack
Public Sub Push(vValue As Variant)
    LangData.Push vValue
    
    mVarsize = LangData.Size
End Sub

' Returns a Key = Phrase pair given its index
Public Function See(Element As Integer) As Variant

    See = LangData.SeePair(Element)
    
End Function

' Updates an entry
Public Sub Change(Key As Variant, vValue As Variant)

    LangData.Change Key, vValue
    
End Sub

' internal function to resize an array
Private Sub Resize(ByRef theArray As Variant)
Dim c As Integer, d As Integer, ending As Integer, starting As Integer
Dim newArray As Variant
starting = 2
ending = UBound(theArray)
ReDim newArray(ending - starting)

c = starting
d = 0
While (c <= ending)
    newArray(d) = theArray(c)
    c = c + 1
    d = d + 1
Wend
    theArray = newArray
End Sub
