Attribute VB_Name = "SimFileMaidMod"
' All code Copyright (C) 1999-2003 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.
'
' A small amount of this code is based Microsoft's example source code
'  and is assumed to be public domain as no copyright was claimed.
' NOTE: All Microsoft example code commented out, 25/05/2004

Option Explicit

' To handle the auto-execution of a browser
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function FindExecutable Lib "shell32.dll" Alias "FindExecutableA" (ByVal lpFile As String, ByVal lpDirectory As String, ByVal lpResult As String) As Long
Public Const SW_SHOWNORMAL = 1

'To allow sleeping
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

' Update WinInet crap
'Public Const INTERNET_OPEN_TYPE_PRECONFIG = 0
'Public Const INTERNET_OPEN_TYPE_DIRECT = 1
'Public Const INTERNET_OPEN_TYPE_PROXY = 3

'Public Const scUserAgent = "Maid Updater 2.2.28"
'Public Const INTERNET_FLAG_RELOAD = &H80000000

'Public Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" _
'(ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, _
'ByVal sProxyBypass As String, ByVal lFlags As Long) As Long

'Public Declare Function InternetOpenUrl Lib "wininet.dll" Alias "InternetOpenUrlA" _
'(ByVal hOpen As Long, ByVal sUrl As String, ByVal sHeaders As String, _
'ByVal lLength As Long, ByVal lFlags As Long, ByVal lContext As Long) As Long

'Public Declare Function InternetReadFile Lib "wininet.dll" _
'(ByVal hFile As Long, ByVal sBuffer As String, ByVal lNumBytesToRead As Long, _
'lNumberOfBytesRead As Long) As Integer

'Public Declare Function InternetCloseHandle Lib "wininet.dll" _
'(ByVal hInet As Long) As Integer

' Const newline
Global NL As String

' Credits flag
Global CreditsFlag As Boolean

' This is the key/value pair for finding where The Sims is installed
'  Thanks to Carsten for the idea to look for this and "auto-detect' it
Global Const REGKEYSIMLOC = "SOFTWARE\Maxis\The Sims"
Global Const SIMLOC = "InstallPath"
' This one seems to be on some systems... It's used if the above isn't there
Global Const SIMALTLOC = "SIMS_DATA"

'The default status bar message
Global DefBarMsg As String

'The default base of the temp folder
Global MaidTemp As String

'Swap string for The Rack
Global RackData As String

'The language name and array
Global LANGCHOICE As String
Global LANGPACK As LanguagePack

' A global as to whether or not to ask during overwrites
Global ConfirmOverwrites As Boolean

' A global as to whether or not to "auto reject" overwrites
Global OverwriteReject As Boolean

' A global as to whether or not to ask when EXEs or found (log but ignore)
Global SkipEXEs As Boolean

' A global as to whether or not to allow The Maid to check the web for updates
Global UpdateCheck As Boolean

' A global to store where the Maid update should be stored
Global UpdateDestPath As String

' A global to help up abort
Global UpdateAbortFlag As Boolean

' A global to store the update interval (in days)
Global UpdateDays As Integer

' A global to determine network availability
Global NetworkUp As Boolean

' A global to determine whether or not we're using The Rack
Global TheRack As Boolean

' A global to determine whether or not we should delete CMX files
'  with skins if they are otherwise unused.
Global TrashCMXWithSkinIfUnused As Boolean

' A global to determine whether or not to tell the user via a
'  message box that Sim File Maid encountered a bad zip.
Global BadZipAlertBox As Boolean

' Globals to tell us where to put different things
Global SimsObjectPath As String
Global SimsSkinsPath As String
Global SimsFloorPath As String
Global SimsWallPath As String
Global SimsArchivePath As String

' A global to where The Sims is installed (I hope)
Global SimsPath As String

' A global to know if we're using a forced path
Global ForceMyPath As Boolean

' Checks the registry to see where The Sims is installed and returns
'   either that value, or the default english-language location
Function Get_SimsPath(Optional ForceOverride As Boolean = False) As String
Dim thePath As String

' ** 1.8 Build 1 - Removed ability to specify The Sims location
'   Via the command line.
'If ((Len(Command)) And Folder_Exists(Command)) Then
    ' If it's specified on the command line
        'Get_SimsPath = Command

On Error GoTo GSPERROR
    
' Allow users to force the reg value
If ((ForceMyPath = True) And (ForceOverride = False)) Then
   ' Check for hardcodes
    thePath = GetSetting(App.Title, "Settings", "SimsPath")
    Write_Log "GETSIMSPATH: *FORCED REG* = " & thePath, 4
Else
    If (GetKeyValue(HKEY_LOCAL_MACHINE, REGKEYSIMLOC, SIMLOC, thePath)) Then
        ' This where Maxis puts the location most all of the time methinks
        Write_Log "GETSIMSPATH: SIMLOC = " & thePath, 4
    ElseIf (GetKeyValue(HKEY_LOCAL_MACHINE, REGKEYSIMLOC, SIMALTLOC, thePath)) Then
        ' Don't know what this is, but Carsten thought it might be useful
        Write_Log "GETSIMSPATH: SIMALTLOC = " & thePath, 4
    ElseIf (Len(GetSetting(App.Title, "Settings", "SimsPath"))) Then
        ' Check for hardcodes
        thePath = GetSetting(App.Title, "Settings", "SimsPath")
        Write_Log "GETSIMSPATH: REG = " & thePath, 4
    Else
        ' Otherwise
        thePath = "C:\Program Files\Maxis\The Sims\"
        Write_Log "GETSIMSPATH: DEF = " & thePath, 4
    End If
End If

' If there isn't a trailing slash, add one
'   The code makes assumptions later on about its existance
If (Right(thePath, 1) <> "\") Then
    thePath = thePath & "\"
End If


'Save it for posterity's sake
SaveSetting App.Title, "Settings", "SimsPath", thePath

Get_SimsPath = thePath
Exit Function

GSPERROR:
Handle_Error LANGPACK.SeeByName("GSPERROR") & " " & Err.Number & ": " & Err.Description, True

End Function


' Make the temp folder and return the name of it
Function Make_Temp() As String
On Error Resume Next
    Dim rndn As Integer, ToBeMade As String, tempDrive As String
    tempDrive = Get_Drive(App.Path)
    
    ' Check to see if there is a temp folder
    If (Not Folder_Exists(tempDrive & "\temp")) Then
        ' No, so make it
        Write_Log "MAKETEMP: Mkdir " & tempDrive & "\temp", 4
        MkDir tempDrive & "\temp"
    End If
    ' Check to see if there's a Maid folder
    If (Not Folder_Exists(tempDrive & "\temp\simfilemaid")) Then
        ' No, so make it
        Write_Log "MAKETEMP: " & tempDrive & "\temp\simfilemaid", 4
        MkDir tempDrive & "\temp\simfilemaid"
    End If
    
    'This segment makes a pseudo-random number between 99 and 9999
    ' to help make the folder names semi-unique. This is bad and
    ' should probably be done differently.
    'It's stuck in a do...while loop to ensure the folder doesn't exist
    Do
        Randomize
        rndn = Int((9999 - 99 + 1) * Rnd + 99)
        ToBeMade = MaidTemp & rndn & "d"
        Write_Log "MAKETEMP: " & ToBeMade & "?", 4
    Loop While (Folder_Exists(ToBeMade))
    
    ' Make it, and return the path
    Write_Log "MAKETEMP: " & ToBeMade, 4
    MkDir ToBeMade
    Make_Temp = ToBeMade
End Function

'Kill the contents of the given temp folder, and then remove the folder
Sub Kill_Temp(kpath As String)
    ' Ignore errors, because killing is non-critical
    Write_Log "KILLTEMP: " & kpath, 4
    On Error Resume Next
    
    'Sanity check - make sure the path is really a temp
    ' folder, because we don't want to delete c:\ or c:\windows
    ' or something silly like that
    If (Left(kpath, Len(MaidTemp)) = MaidTemp) Then
        ' Kill the contents, then remove the folder
        Write_Log "KILLTEMP: Killing " & kpath & " contents", 4
        Kill kpath & "\*.*"
        Write_Log "KILLTEMP: Killing " & kpath & " folder", 4
        RmDir kpath
    Else
        ' Doesn't match up, there's a problem.
        '  I should probably "end" on this error, but I don't want to
        Write_Log "KILLTEMP: Could not remove temp folder " & kpath & "as the name appears incorrect!", 1
    End If
End Sub
'Is the thing a letter?
Function IsLetter(toTest As String) As Boolean

    Dim asciivalue As Integer
    asciivalue = Asc(Left(toTest, 1))
    If ((asciivalue >= 65) And (asciivalue <= 90)) Then
        IsLetter = True
    ElseIf ((asciivalue >= 97) And (asciivalue <= 122)) Then
        IsLetter = True
    Else
        IsLetter = False
    End If

End Function

' This function actually handles the unzipping and such.
'   It includes free code from the Info-Zip project. See comments
'   in the VBUnzip.bas file for details
Function Do_ZipFile(ZipFilePath As String) As Integer
    
    ' Build the temp folder for this zip
    Dim TempFilePath As String
    TempFilePath = Make_Temp()

    '### All of the below stuff handles configuration to
    '### tell the Info-Zip library what to do with the Zip
    '### These variables are all in VBUnzip.bas
    
    '-- Init Global Message Variables
    uZipInfo = ""
    uZipNumber = 0   ' Holds The Number Of Zip Files
    
    '-- Select UNZIP32.DLL Options - Change As Required!
    uPromptOverWrite = 0  ' 1 = Prompt To Overwrite
    uOverWriteFiles = 1   ' 1 = Always Overwrite Files
    uDisplayComment = 0   ' 1 = Display comment ONLY!!!
    
    '-- Change The Next Line To Do The Actual Unzip!
    uExtractList = 0       ' 1 = List Contents Of Zip 0 = Extract
    uHonorDirectories = 0  ' 1 = Honour Zip Directories
    
    '-- Select Filenames If Required
    '-- Or Just Select All Files
    uZipNames.uzFiles(0) = vbNullString
    uNumberFiles = 0
    
    '-- Select Filenames To Exclude From Processing
    ' Note UNIX convention!
    '   vbxnames.s(0) = "VBSYX/VBSYX.MID"
    '   vbxnames.s(1) = "VBSYX/VBSYX.SYX"
    '   numx = 2
    
    '-- Or Just Select All Files
    uExcludeNames.uzFiles(0) = vbNullString
    uNumberXFiles = 0
    

    'The path to the zip
    uZipFileName = ZipFilePath
    'Where we want the contents
    uExtractDir = TempFilePath
    
    'After setting all of that stuff, call the action
    ' function to do it
    Dim unzRet
    unzRet = VBUnZip32()
    
    ' Handle error if any
    If (unzRet <> 0) Then
        Write_Log "BAD ZIP: " & ZipFilePath, 2
        If (BadZipAlertBox) Then
            Handle_Information LANGPACK.ProperString("BADZIP", ZipFilePath)
        End If
        Do_ZipFile = 0
    End If
    
    On Error GoTo DZError
    
    Dim itPath As String, itItem As String, itCount As Integer, Filezs As MArray
    itCount = 0                   ' Set the initial file count
    Set Filezs = Get_Files(TempFilePath)
    While (Filezs.Size > 0)
        itItem = Filezs.Pop
        ' Ignore the current directory and the encompassing directory.
        If ((itItem <> ".") And (itItem <> "..")) Then
            ' Increment itCount by the amount returned by Hande_File
            '  Handle_File is actually the worker function here.
            ' **NOTE: Because Handle_File calls Do_ZipFile to handle
            '  .Zip files, this is recursive and may be a performance
            '  bottleneck. This isn't a problem for this program because
            '  it is so trivial.
            itCount = itCount + Handle_File(itItem)
        End If
    Wend

    ' Okay, we're done with this zip and its contents
    '  Kill the temp folder and return the number of files "installed"
    Kill_Temp (TempFilePath)
    Do_ZipFile = itCount
    Exit Function
    
DZError:
    Write_Log "DOZIP: " & ZipFilePath & " - " & Err.Number & ": " & Err.Description, 1
    Do_ZipFile = 0
    
End Function
' Handle file copying where needed
Function Handle_FileCopy(srcPath As String, destPath As String)

    'check for existance of destPath and warn if overwrite?
    '  Nested the ifs to improve performance for users not using this option
    If (File_Exists(destPath)) Then
        On Error Resume Next
        SetAttr destPath, vbNormal
        On Error GoTo 0
        Write_Log "FILE EXISTS: " & destPath, 4
        If (ConfirmOverwrites) Then
            If (MsgBox(LANGPACK.ProperString("FILEEXISTS", destPath), vbYesNo + vbQuestion, App.Title & " File Management Wizard") = vbNo) Then
                'They said no
                Write_Log "OVERWRITE REJECTED"
                Handle_FileCopy = 0
                Exit Function
            End If
        ElseIf (OverwriteReject) Then
            Write_Log "OVERWRITE AUTO-REJECTED", 4
            Handle_FileCopy = 0
            Exit Function
        End If
    End If
        
    On Error Resume Next
    ' Ensure not read only on the file and the dest folder
    SetAttr Get_FolderPath(destPath), vbNormal
    On Error GoTo 0
    
    ' DEBUG-only check. If the sourcefile has disappeared, say so.
    If (LogLevel = 4) Then
        If (Not File_Exists(srcPath)) Then
            Write_Log "HANDLEFILECOPY: Debugging shows " & srcPath & " does not exist!", 4
        End If
    End If
    
    On Error GoTo FCError
    ' Do the copy
    FileCopy srcPath, destPath
    
    Handle_FileCopy = 1
    Exit Function
    
FCError:
    Write_Log "HANDLEFILECOPY: There was an error while copying " & srcPath & " to " & destPath & ". " & Err.Number & ": " & Err.Description, 1
    Handle_Error LANGPACK.ProperString("FCERROR", srcPath, destPath) & LANGPACK.ProperString("ERRORREPORT", App.Path & "\SimFileMaid.log")
    Handle_FileCopy = 0

End Function
' Given a file, Do The Right Thing (tm) with it
Function Handle_File(FilePath As String) As Integer
    
    ' Changed to Resume Next with the Goto further down as SetAttr
    '  on a R/O filesystem is probably causing stupid errors.
    On Error Resume Next
    
    ' Clear any stupid read-only, hidden or system bits on the file
    '  If we don't do this, killing the files (thus removing the folder)
    '  will fail when the file originated from a zip (and thus is temporary)
    SetAttr FilePath, vbNormal
    
    'Extract just the filename from the path
    Dim fileName As String
    fileName = "\" & Get_Filename(FilePath)
    
    On Error GoTo Copy_Error
    ' This is a switch table, it switches on the lower-cased last 4
    '  characters of the filename
    Select Case LCase(Right(FilePath, 4))
        Case ".exe"
            Write_Log "EXE: " & FilePath
            If (SkipEXEs) Then
                Write_Log "SkipEXEs: " & FilePath, 2
            Else
                ' Treat .exe's as unsafe. Let the user bury themselves if they'd like
                ' Strip the leading "\"
                Dim Efilename As String
                Efilename = Right(fileName, Len(fileName) - 1)
            
                If (MsgBox(LANGPACK.ProperString("EXEQUERY", Efilename), vbInformation + vbYesNo, App.Title) = vbYes) Then
                    Write_Log "Execution approved"
                    Shell FilePath, vbNormalFocus
                    Handle_Information LANGPACK.SeeByName("EXEPOST")
                Else
                    Write_Log "EXE: " & FilePath & " manually skipped", 2
                End If
            End If
            'Dunno what it did, so don't count it.
            Handle_File = 0
        Case ".zip"
            ' Zip file
            Write_Log "ZIP: " & FilePath
            Handle_File = Do_ZipFile(FilePath)
        Case ".flr"
            ' Floor
            Write_Log "FLOOR: " & FilePath & " -> " & SimsPath & SimsFloorPath & fileName
            Handle_File = Handle_FileCopy(FilePath, SimsPath & SimsFloorPath & fileName)
        Case ".wll"
            ' Wall file
            Write_Log "WALL: " & FilePath & " -> " & SimsPath & SimsWallPath & fileName
            Handle_File = Handle_FileCopy(FilePath, SimsPath & SimsWallPath & fileName)
        Case ".skn", ".cmx", ".bmp", ".cfp"
            ' Skin related file (we hope - it could be a roof .bmp)
            Write_Log "SKIN: " & FilePath & " -> " & SimsPath & SimsSkinsPath & fileName
            Handle_File = Handle_FileCopy(FilePath, SimsPath & SimsSkinsPath & fileName)
        Case ".iff"
            ' Object file (we hope - it could be a house .iff)
            Write_Log "OBJECT: " & FilePath & " -> " & SimsPath & SimsObjectPath & fileName
            Handle_File = Handle_FileCopy(FilePath, SimsPath & SimsObjectPath & fileName)
        Case ".far"
            ' Object archive
            Write_Log "FAR: " & FilePath & " -> " & SimsPath & SimsArchivePath & fileName
            Handle_File = Handle_FileCopy(FilePath, SimsPath & SimsArchivePath & fileName)
        Case Else
            ' Something else, dunno what it is.
            Write_Log "UNHANDLED: " & FilePath, 2
            Handle_File = 0
    End Select
Exit Function

Copy_Error:
    Write_Log "HANDLEFILE: " & FilePath & " - " & Err.Number & ": " & Err.Description, 1
    Handle_File = 0
    
End Function

' Loads the specified language pack
Sub Load_Language()
    Dim L As MArray, Def As MArray
    Set L = New MArray
    Set Def = New MArray
    
    
    If (File_Exists(App.Path & "\langs\" & LANGCHOICE)) Then
        Set Def = Get_Lines(App.Path & "\langs\lang.0eng.txt")
        Set LANGPACK = New LanguagePack
        LANGPACK.Initialize Def.Give
        
        If (LANGCHOICE <> "lang.0eng.txt") Then
            Set L = Get_Lines(App.Path & "\langs\" & LANGCHOICE)
            LANGPACK.Update L.Give
        End If
        
        'set the menu
        With mainForm
            .helpMenuOption.Caption = LANGPACK.SeeByName("HELP")
            .langMenuOption.Caption = LANGPACK.SeeByName("LANGOPT")
            .rackMenuOption.Caption = LANGPACK.SeeByName("Rackopt")
            .aboutMenuOption.Caption = LANGPACK.SeeByName("CREDopt")
            .logMenuOption.Caption = LANGPACK.SeeByName("LOGGopt")
            .otherMenuOptions.Caption = LANGPACK.SeeByName("OTHEROPT")
            .updateCheckMenuOption.Caption = LANGPACK.SeeByName("CHECKOPT")
            .SBar.SimpleText = LANGPACK.SeeByName("Defbarmsg")
        End With
    Else
        Handle_Error "Language data cannot be loaded and as such I cannot continue.", True
    End If
    
    
End Sub

'Get the CMX files in a folder that match a pattern
Function Get_CMXs(FilePath As String) As MArray
    Dim CMXs As MArray, cmxName As String, preFile As String, foldername As String, fileName As String
    Set CMXs = New MArray
    
    foldername = Get_FolderPath(FilePath)
    fileName = Get_Filename(FilePath)
    cmxName = Left(fileName, InStr(1, fileName, "_", vbTextCompare) - 4)
    preFile = Dir(foldername & cmxName & "*.cmx", vbDirAllFiles)
    Do While preFile <> ""
        Write_Log "GETCMXS: " & preFile, 4
        CMXs.Push foldername & preFile
        preFile = Dir
    Loop
    
    Set Get_CMXs = CMXs

End Function
'Extract the language name from a file
Function Get_Lang_Name(langFile As String) As String
    Dim lineIn As String
If (Not File_Exists(langFile)) Then
    Get_Lang_Name = "0"
    Exit Function
Else
    Dim FileNum As Integer
    FileNum = FreeFile
    Open langFile For Input As #FileNum
    Line Input #FileNum, lineIn
    Close #FileNum

    Get_Lang_Name = lineIn
End If


End Function
' Get the lines from a file
Function Get_Lines(FilePath As String, Optional removeCrap As Boolean = True) As MArray
    Dim GL As MArray, FN As Integer
    Set GL = New MArray

    FN = FreeFile
    Open FilePath For Input As #FN
    Do While Not EOF(FN)
        Dim T As String
        Line Input #FN, T
        If (removeCrap) Then
            T = Trim(T)
            If (Len(T) And (Left(T, 1) <> "#") And (Left(T, 1) <> "'")) Then
                GL.Push (T)
            End If
        Else
            GL.Push (T)
        End If
    Loop
    Close #FN

    Set Get_Lines = GL

End Function



'Get the files in a folder
Function Get_Files(Pattern As String) As MArray

    Dim filez As MArray, preFile As String, folderPath As String
    Set filez = New MArray
    
    folderPath = Get_FolderPath(Pattern)
    
    preFile = Dir(Pattern, vbDirAllFiles)
    Do While preFile <> ""
        filez.Push folderPath & preFile
        preFile = Dir
    Loop
    
    Set Get_Files = filez

End Function

'Extract the language author from a file
Function Get_Lang_Author(langFile As String) As String
    Dim lineIn As String
If (Not File_Exists(langFile)) Then
    Get_Lang_Author = "0"
    Exit Function
Else
    Dim FileNum As Integer
    FileNum = FreeFile
    Open langFile For Input As #FileNum
    Line Input #FileNum, lineIn
    Line Input #FileNum, lineIn
    Close #FileNum

    Get_Lang_Author = lineIn
End If
End Function

'Extract the language name and author from a file
Function Get_Lang_Header(langFile As String) As String

    Dim lineIn As String, lineIn2 As String
If (Not File_Exists(langFile)) Then
    Get_Lang_Header = "0"
Else
    Dim FileNum As Integer
    FileNum = FreeFile
    Open langFile For Input As #FileNum
    Line Input #FileNum, lineIn
    Line Input #FileNum, lineIn2
    Close #FileNum

    Get_Lang_Header = lineIn & " = " & lineIn2
End If
End Function

' Get all of the language headers
Function Get_Lang_Headers() As Hash
    Dim filez As MArray, headers As Hash
    Set filez = New MArray
    Set headers = New Hash

    Set filez = Get_Files(App.Path & "\langs\lang.*")
    
    While (filez.Size > 0)
        Dim mFile As String
        mFile = filez.Pop
        headers.Push Get_Lang_Header(mFile)
    Wend
    
    Set Get_Lang_Headers = headers

End Function
'Check for updates
Sub Check_Updates(Optional Interactive As Boolean = False)
    
   ' On Error GoTo CHKUPDERR
    'If (Is_Net()) Then
    '    Dim webVersion As String, ynRes As Integer
    '    webVersion = Get_Version()
    '    If (Is_VersionNewer(webVersion)) Then
    '        Write_Log "UPDATE: " & webVersion & " available", 4
    '        If (MsgBox(LANGPACK.SeeByName("updatefound"), vbYesNo + vbQuestion, App.Title & " Updater") = vbYes) Then
    '            Write_Log "UPDATE: Download accepted", 4
    '            mainForm.FileBrowser.ShowSave
    '            UpdateDestPath = mainForm.FileBrowser.fileName
    '            Write_Log "UPDATE: Will be saved to " & UpdateDestPath, 4
    '            updateForm.Show vbModal
    '        Else
    '            Write_Log "UPDATE: Download rejected. -1 to Karma", 4
    '        End If
    '    Else
    '        Write_Log "UPDATE: Web versions " & webVersion & " is not newer. Not updating.", 4
    '        SaveSetting App.Title, "Settings", "LastUpdateTime", Now
    '        If (Interactive) Then
    '            MsgBox LANGPACK.SeeByName("NOUPDATE"), vbInformation, App.Title & " Updater"
    '        End If
    '    End If
    'ElseIf (Interactive) Then
    '    'no net
    '    Write_Log "UPDATES: No net present on interactive update", 4
    '    MsgBox LANGPACK.SeeByName("NOUPDATE"), vbInformation, App.Title & " Updater"
    'End If
    'Exit Sub
'CHKUPDERR:
   ' Write_Log "CHKUPDERR: " & Err.Number & ": " & Err.Description, 1
    
End Sub

'Compare current time to the time of the last update
Function Is_UpdateTime() As Boolean
'If (Len(GetSetting(App.Title, "Settings", "LastUpdateTime"))) Then
'    Dim luT As Variant, cuT As Variant
'    luT = CVar(GetSetting(App.Title, "Settings", "LastUpdateTime"))
'    cuT = Now
'    If ((CDate(cuT) - CDate(luT)) >= UpdateDays) Then
'        Is_UpdateTime = True
'    Else
'        Is_UpdateTime = False
'    End If
'Else
'   Is_UpdateTime = True
'End If
End Function
'Should we even try to update The Maid?
Function Should_Update() As Boolean
 '   If (UpdateCheck = False) Then
 '       Should_Update = False
 '   ElseIf (Not Is_UpdateTime()) Then
 '       Should_Update = False
 '   Else
 '       Should_Update = True
 '   End If
    
End Function
'Test for a net connection
Function Is_Net() As Boolean

'On Error GoTo ISNETERR

 '   Dim E As ICMP_ECHO_REPLY, Eres As Long
    ' Ping mattwork. I know I should use names instead of numbers but
    '  ya' know.....?
  '  Eres = Ping("137.143.107.3", E)
    
  '  Write_Log "PING: " & CStr(Eres) & ": " & CStr(E.status), 4
  '  If (Eres = 0) Then
  '      NetworkUp = True
  '  Else
  '      NetworkUp = False
  '  End If
    
  '  Is_Net = NetworkUp
  '  Exit Function
'ISNETERR:
  '  Write_Log "ISNETERR: " & Err.Number & ": " & Err.Description, 1
   ' Is_Net = False
    
End Function

'Fetch the "new" version number
Function Get_Version() As String
   ' Dim hOpen               As Long
   ' Dim hOpenUrl            As Long
   ' Dim sUrl                As String
   ' Dim bDoLoop             As Boolean
   ' Dim bRet                As Boolean
   ' Dim sReadBuffer         As String * 2048
   ' Dim lNumberOfBytesRead  As Long
   ' Dim sBuffer             As String
    
   ' On Error GoTo GVERROR
   ' sUrl = "http://mattwork.potsdam.edu/projects/SimFileMaid/current.txt"
    
   ' hOpen = InternetOpen(scUserAgent, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)
   ' hOpenUrl = InternetOpenUrl(hOpen, sUrl, vbNullString, 0, INTERNET_FLAG_RELOAD, 0)

   ' bDoLoop = True
   ' While bDoLoop
   '     sReadBuffer = vbNullString
   '     bRet = InternetReadFile(hOpenUrl, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
   '     sBuffer = sBuffer & Left$(sReadBuffer, lNumberOfBytesRead)
   '     If Not CBool(lNumberOfBytesRead) Then bDoLoop = False
   ' Wend
    
   ' If hOpenUrl <> 0 Then InternetCloseHandle (hOpenUrl)
   ' If hOpen <> 0 Then InternetCloseHandle (hOpen)

   ' Get_Version = sBuffer
   ' Exit Function
'GVERROR:
    'Write_Log "GETVERS: " & Err.Number & ": " & Err.Description, 1
    'Get_Version = "0.0.0"
    
End Function

'Is the given version number greater than the current version?
Function Is_VersionNewer(vNumber As String) As Boolean
    
    'Sanity check
   ' If (vNumber = "") Then
   '     Is_VersionNewer = False
   '     Exit Function
   ' End If

   ' Dim majorV As Integer, minorV As Integer, buildV As Integer, tV As Variant
   ' tV = Split(vNumber, ".")
   ' majorV = CInt(tV(0))
   ' minorV = CInt(tV(1))
   ' buildV = CInt(tV(2))
    
   ' If (majorV > App.Major) Then
   '     'Newer
   '     Is_VersionNewer = True
   ' ElseIf (majorV = App.Major) Then
   '     'Dig deeper
   '     If (minorV > App.Minor) Then
   '         'greater
   '         Is_VersionNewer = True
   '     ElseIf (minorV = App.Minor) Then
   '         'deeper still
   '         If (buildV > App.Revision) Then
   '             'greater
   '             Is_VersionNewer = True
   '         ElseIf (buildV = App.Revision) Then
   '             'same version
   '             Is_VersionNewer = False
   '         Else
   '             'less
   '             Is_VersionNewer = False
   '         End If
   '     Else
   '         'less
   '         Is_VersionNewer = False
   '     End If
   ' Else
   '     ' must be less
   '     Is_VersionNewer = False
   ' End If
End Function
