VERSION 5.00
Begin VB.Form langPickForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form1"
   ClientHeight    =   2010
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2010
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton okButton 
      Default         =   -1  'True
      Height          =   615
      Left            =   120
      Picture         =   "langPickForm.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   1320
      Width           =   4455
   End
   Begin VB.Frame langFrame 
      Caption         =   "Languages"
      Height          =   1095
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   4455
      Begin VB.OptionButton langOption 
         Caption         =   "Option Button"
         Height          =   375
         Index           =   0
         Left            =   240
         TabIndex        =   0
         Top             =   360
         Width           =   3975
      End
   End
End
Attribute VB_Name = "langPickForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' All code Copyright (C) 2002 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.

Dim langs As MArray
Dim langIndex As Integer

Private Sub Form_Load()

On Error GoTo langLoadErr

Me.Caption = App.Title & " - Language Options"
Me.Icon = mainForm.Icon

Dim c As Integer, hdiff As Integer
Set langs = Get_Files(App.Path & "\langs\lang.*")
c = 0
langIndex = 0
hdiff = Me.Height - langFrame.Height

If (Len(LANGCHOICE)) Then
    langFrame.Caption = LANGPACK.SeeByName("LANGUAGE")
End If

' Add all of the langauges, making adjustments where necessary
While c < langs.size
    Dim PREV As Integer
    If (c = 0) Then
        PREV = 0
    Else
        PREV = c - 1
    End If
    
    If (c > 0) Then
        ' Create a new option button in the array
        Load langOption(c)
    End If
    With langOption(c)
        If (c > 0) Then
            ' Set its value to false, by default
            .Value = False
            ' Line it up with the last
            .Left = langOption(PREV).Left
            .Top = langOption(PREV).Top + langOption(PREV).Height + 10
            
            ' Adjust the frame and form height if necessary
            If ((.Top + .Height) >= (langFrame.Height - langFrame.Top)) Then
                langFrame.Height = .Top + .Height + 120
                If ((langFrame.Height - langFrame.Top) >= (Me.Height - hdiff)) Then
                    Me.Height = langFrame.Height + langFrame.Top + hdiff
                    okButton.Top = langFrame.Height + langFrame.Top + 120
                End If
            End If
        End If
        'Set the caption, make it visible, set the tab index
        .Caption = Get_Lang_Name(langs.See(c))
        .Visible = True
        .TabIndex = c + 1
    End With
    c = c + 1
Wend

c = 0
While c <= langOption.UBound
    If (StrComp(Get_Filename(langs.See(c)), LANGCHOICE, vbTextCompare) = 0) Then
        ' This is the currently selected language
        '  Make its value true
        langOption(c).Value = True
    End If
    c = c + 1
Wend

Exit Sub

langLoadErr:
    Handle_Error LANGPACK.SeeByName("LANGOPT") & " " & LANGPACK.ProperString("ERRORNUMBER", Err.Number) & ": " & Err.Description, False

    
End Sub


Private Sub Form_Unload(Cancel As Integer)

If ((Len(LANGCHOICE) = 0) And (langIndex <> -1)) Then
    ' No language was chosen AND there never has been one selected.
    MsgBox "You must select a language to continue", vbInformation, App.Title & " Setup Wizard"
    End
End If

End Sub

Private Sub langOption_Click(Index As Integer)
    langIndex = Index
End Sub

Private Sub okButton_Click()

    'They picked, so save it
    Dim langName As String
    langName = Get_Filename(langs.See(langIndex))
    SaveSetting App.Title, "Settings", "LangChoice", langName
    langIndex = -1
    
    Unload Me
End Sub
